package org.gcube.data.access.storagehub.storage.backend.impl;

import javax.inject.Singleton;

import org.gcube.common.storagehub.model.Constants;
import org.gcube.common.storagehub.model.Metadata;
import org.gcube.common.storagehub.model.exceptions.InvalidCallParameters;
import org.gcube.common.storagehub.model.items.nodes.PayloadBackend;
import org.gcube.common.storagehub.model.storages.StorageBackend;
import org.gcube.common.storagehub.model.storages.StorageBackendFactory;

@Singleton
public class GCubeMongoStorageBackendFactory implements StorageBackendFactory {

	@Override
	public String getName() {
		return Constants.MONGO_STORAGE;
	}

	@Override
	public StorageBackend create(PayloadBackend payloadConfiguration) throws InvalidCallParameters {
		return new GCubeMongoStorageBackend(payloadConfiguration);
	}
	
}
